#include "cx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static long prec_base10 = 0;

long
cbitprec(void)
{
#if   defined(mplib_pari)
  return 8*sizeof(long)*(prec-3);
#elif defined(mplib_ntl)
  return RE::precision();
#else
  return 50;
#endif
}

long
cdigitprec(void)
{
#if   defined(mplib_pari)
#elif defined(mplib_ntl)
#else
  return 16;
#endif
  return prec_base10;
}

#if  !defined(mplib_pari)
#define L2SL10 (0.301029995663981)
#endif
#define tobase02(base10) (static_cast<long>((base10)/L2SL10))
#define tobase10(base02) (static_cast<long>((base02)*L2SL10))
static void
setprec(const long base02, const long base10)
{
  prec_base10 = base10;
#if   defined(mplib_pari)
  prec = 3 + base02/8/sizeof(long);
#elif defined(mplib_ntl)
  RE::SetOutputPrecision(base10);
  RE::SetPrecision(base02);
#endif
}

void
setcbitprec(const long base02)
{ setprec(base02, tobase10(base02)); }
void
setcdigitprec(const long base10)
{ setprec(tobase02(base10), base10); }

#if defined(mplib_pari)         /* proto */
/* On dfinit un `gaffect' pour augmentation de prcision */
static void
gaffectzero(const GEN x, GEN y)
{
  gaffect(gcmp0(x) ? gzero : x, y);
}

#ifdef __complex__
/* Ceci est aussi dfini dans lib/cx-io.c */
static GEN
grealpart(const GEN x) {
  switch(typ(x)) {
    case t_INT: case t_REAL: case t_FRAC: case t_FRACN: return x;
    case t_COMPLEX:                                     return ((GEN*)x)[1];
    default:                   err(typeer,"grealpart"); return NULL;
  }
}
static GEN
gimagpart(const GEN x) {
  switch(typ(x)) {
    case t_INT: case t_REAL: case t_FRAC: case t_FRACN: return gzero;
    case t_COMPLEX:                                     return ((GEN*)x)[2];
    default:                   err(typeer,"gimagpart"); return NULL;
  }
}
#endif

void
rprec(RE& r)
{
  GEN z = cgetr(prec); gaffectzero( r.v, z ); r.v = z;
}

void
cprec(CX& c)
{
#ifdef __complex__
  GEN C;
  C = cgetg(3,t_COMPLEX);
  ((GEN*)C)[1] = cgetr(prec); gaffectzero( grealpart(c), ((GEN*)C)[1] );
  ((GEN*)C)[2] = cgetr(prec); gaffectzero( gimagpart(c), ((GEN*)C)[2] );
  c = C;
#else
  rprec( c.x );
  rprec( c.y );
#endif
}
#endif                          /* proto */
