#ifndef H_SOLVE
#define H_SOLVE

// Soit f une fonction de C^m dans C^n
// Soit x une approximation dans C^m d'un zero de f
// On veut amliorer cette approximation
//
// On fournit x, - f(x) et f'(x)

#include "cx.h"
#include "vecteur.h"
#include "polynome.h"

enum solve { nulldet, dicho };

extern VECTEUR delta
       (const VECTEUR& x, const VECTEUR& fx, const MCARREE& der);
extern VECTEUR dichosolve
       (const VECTEUR& x, const VECTEUR& fx, const MCARREE& der,
              VECTEUR (*f) (const VECTEUR& x) );

extern VECTEUR racines (const POLYNOME& p, const VECTEUR& estimation);

#endif
